package org.erif.util;


import java.io.*;
import java.sql.*;
import javax.sql.*;
import javax.naming.*;

import javax.servlet.http.HttpServlet; // to extend, for init
import javax.servlet.ServletException; // thrown by init

/** DbUtil needs to be init with the "dburl" to get connections from.  
 * See your web.xml, load-on-startup, init-param... for instance: <pre>  <servlet>
 *   &lt;servlet-name&gt;dbutil&lt;/servlet-name&gt;
 *   &lt;servlet-class&gt;org.erif.util.DbUtil&lt;/servlet-class&gt;
 *   &lt;init-param&gt;
 *     &lt;param-name&gt;dburl&lt;/param-name&gt;
 *     &lt;param-value&gt;jdbc/zspace.calendar&lt;/param-value&gt;
 *   &lt;/init-param&gt;
 *   &lt;load-on-startup&gt;1&lt;/load-on-startup&gt;
 * &lt;/servlet&gt;
</pre>
 */
public class DbUtil extends HttpServlet {

  public void init() throws ServletException {
    url = getServletConfig().getInitParameter("dburl");
  }

  public static void setDbURL(String s) {
    url = s;
  }

  private static String url;

  /** Gets a new Connection from the pool manager */
  public static Connection getConnection() throws SQLException {
    Connection retval=null;
    if (url == null) throw new SQLException("no dburl found");
    try {
      Context env = (Context)new InitialContext().lookup("java:comp/env");
      DataSource source = (DataSource)env.lookup(url);
      retval = source.getConnection();
    } catch (NamingException ne) { //unable to get Context/lookup
      throw new SQLException("unable to get context/lookup: "+ne.toString());
    //} catch (SQLException sqle) { //unable to getConnection
      //NOTDONE
    }
    return retval;
  }

}
