package org.erif.util;

import java.util.*;

/** for holding a list of errors, named errors, or some combination thereof; for keeping track of, for instance, validation errors while rolling through processing of a form */
public class FormUtil {

  private Hashtable errors=new Hashtable();

  public boolean hasErrors() { return errors.size() != 0; }

  public boolean hasError(String s) {
    return errors.get(s) != null;
  }

  public String getError(String s) {
    return (String)errors.get(s);
  }

  public Iterator getErrors() { 
    return errors.values().iterator(); 
  }

  public Iterator getErrorKeys() { 
    return errors.keySet().iterator(); 
  }

  public void addError(String s) { 
    errors.put(s,s); 
  }

  public void addError(String key, String value) {
    errors.put(key,value);
  }

  public void clearErrors() { errors.clear(); }

}
