package org.erif.util;

import java.io.*;
import java.awt.*;
//import javax.imageio.*;
import java.awt.image.*;
import com.sun.image.codec.jpeg.*;

/** TODO: FIX: NOTE TO SELF: getScaledInstance can take negatives for width or height, thus scaling that parameter to maintain the aspect ratio of the original image dimensions !!! */

public class ImageUtil {

  public static void writeAsJPEG(Image i, OutputStream o) throws IOException {
    writeAsJPEG(i,o,.5f);
  }

  public static void writeAsJPEG(Image i, OutputStream o, float quality) throws IOException {
    BufferedOutputStream out;
    if (!(o instanceof BufferedOutputStream)) {
      out = new BufferedOutputStream(o,1024*10); //TODO: scale to image size?
    } else out = (BufferedOutputStream) o;
    BufferedImage bsImage = new BufferedImage(i.getWidth(null),i.getHeight(null),BufferedImage.TYPE_INT_RGB);
    Graphics2D g2d = bsImage.createGraphics();
    g2d.drawImage(i,0,0,i.getWidth(null),i.getHeight(null),null);
    JPEGImageEncoder encoder = JPEGCodec.createJPEGEncoder(out);
    JPEGEncodeParam param = encoder.getDefaultJPEGEncodeParam(bsImage);
    param.setQuality(quality,false);
    encoder.setJPEGEncodeParam(param);
    encoder.encode(bsImage);
  }
 
  public static Image getImage(File f) throws IOException {
    return getImage(JavaUtil.readBytes(f));
  }

  public static Image getImage(byte[] data) {
    Toolkit toolkit = Toolkit.getDefaultToolkit();
    Image image = toolkit.createImage(data);
    toolkit.prepareImage(image,-1,-1,null);
    while ((toolkit.checkImage(image,-1,-1,null) & ImageObserver.ALLBITS) == 0)
      try { Thread.sleep(10); } catch (Exception e) {}
    return image;
  }

  public static Image scale(Image i, int w, int h) {
    int hints = Image.SCALE_SMOOTH; // _DEFAULT, _SMOOTH, _AREA_AVERAGING, _FAST
    return scale(i,w,h,hints);
  }

  public static Image scale(Image i, int w, int h, int hints) {
    Image scaledImage = i.getScaledInstance(w,h,hints);
    Toolkit toolkit = Toolkit.getDefaultToolkit();
    while ((toolkit.checkImage(scaledImage,-1,-1,null) & ImageObserver.ALLBITS) == 0)
      try { Thread.sleep(10); } catch (Exception e) {}
    return scaledImage;
  }

  public static Image scaleToWidth(Image i, int w) {
    float ratio = getWidthHeightRatio(i);
    return scale(i,w,(int)(w/ratio));
  }

  public static Image scaleToHeight(Image i, int h) {
    float ratio = getHeightWidthRatio(i);
    return scale(i,(int)(h/ratio),h);
  }

  public static Image scaleToLongest(Image i, int size) {
    return (i.getWidth(null) > i.getHeight(null))?
      scaleToWidth(i,size):
      scaleToHeight(i,size);
  }

  public static Image scaleToShortest(Image i, int size) {
    return (i.getWidth(null) > i.getHeight(null))?
      scaleToHeight(i,size):
      scaleToWidth(i,size);
  }

  public static float getHeightWidthRatio(Image i) {
    int width = i.getWidth(null);
    int height = i.getHeight(null);
    if (width == 0) return Float.POSITIVE_INFINITY;
    return (float)height/(float)width;
  }

  public static float getWidthHeightRatio(Image i) {
    float inverse = getHeightWidthRatio(i);
    if (inverse == 0) return Float.POSITIVE_INFINITY; 
    return 1.0f/inverse;
  }

}
